// console.log("load gaugesScreen");
angular.module('gaugesScreen', [])

  .controller('GaugesScreenController', function ($scope, $element, $window) {
    "use strict";
    var vm = this;

    var svg;

    var speedoDisplay = { };
    var infoDisplay = {};
    var electrics = {lights:{} };
    var gagues = {fuel:{},temp:{}};
    let gmeter = {};
    let dragLayer = {}

    var speedoInitialised = true;
    var cachedVal = { temp:-100, fuel:-100, gForcesVisible: false, dragMode: false};

    var ready = false;

    var unitTorque = "imperial";
    var unitPower = "hp";
    var unitLength = "metric"
    var unitspeedConv = 3.6;

    function updateClock(){
      let date = new Date();
      let h = date.getHours(); // 0 - 23
      let m = date.getMinutes(); // 0 - 59
      let s = date.getSeconds();
      //h = h%12 +1
      m = (m < 10)? "0"+m : m
      let timeStr = h +":"+m //+":" + s
      speedoDisplay.clockTxt.text(timeStr)
      setTimeout(updateClock, 1000);
    }

    // Make sure SVG is loaded
    $scope.onSVGLoaded = function () {
      svg = $element[0].children[0].children[0];

      // speedometer
      speedoDisplay.root = hu('#layer6', svg); //label= txt
      speedoDisplay.rootspeedo = hu('#speedometer', svg); //label= txt
      speedoDisplay.speedometerText = hu('#speedometerText', speedoDisplay.rootspeedo)
      speedoDisplay.speedUnit = hu('#speedUnit', speedoDisplay.rootspeedo);
      speedoDisplay.clockTxt = hu('#clock_txt', speedoDisplay.root)

      // speedoDisplay.speedValue = hu('#speedValue', speedoDisplay.speedometerText);
      // speedoDisplay.speedValues = []
      // speedoDisplay.speedValues.push(speedoDisplay.speedValue.n.querySelector("#tspanSpdUnit") );
      // speedoDisplay.speedValues.push(speedoDisplay.speedValue.n.querySelector("#tspanSpdDizaine") );
      // speedoDisplay.speedValues.push(speedoDisplay.speedValue.n.querySelector("#tspanSpdCentaine") );
      speedoDisplay.gear = hu('#gear_txt', speedoDisplay.root);

      gagues.fuel.needle = hu('#needle_fuel', svg);
      gagues.fuel.grad = hu('#linGrad_fuel', svg);
      gagues.fuel.path = hu('#path_fuel', svg);

      gagues.temp.needle = hu('#needle_temp', svg);
      gagues.temp.grad = hu('#linGrad_temp', svg);
      gagues.temp.path = hu('#path_temp', svg);

      electrics.odo_txt = hu("#odo_txt", electrics.root);
      electrics.battery_txt = hu('#battery_level', electrics.root)
      electrics.mode_txt = hu("#mode_txt", electrics.root);
      electrics.mode_txt.text("ready")

      gmeter.root = hu("#gmeter-layer",svg)
      gmeter.circle = hu("#gmeter-circle",gmeter.root)

      dragLayer.root = hu('#drag_layer', svg);
      dragLayer.linelock_light = hu('#linelock_light', dragLayer.root);
      dragLayer.transbrake_light = hu('#transbrake_light', dragLayer.root);
      dragLayer.torque_txt = hu('#text_torque', dragLayer.root);
      dragLayer.power_txt = hu('#text_power', dragLayer.root);

      ready = true;
      updateClock();
      // console.log("rdy")
    }

    function limitVal(min, val,max){
        return Math.min(Math.max(min,val), max);
    }

    function updateAccelerometer(data) {
      //86
      gmeter.circle.css({transform: `translate(${limitVal(-10,data.customModules.accelerationData.xSmooth,10)*8}px, ${-limitVal(-10,data.customModules.accelerationData.ySmooth,10)*8}px`})
      // var roundedGX2 = (data.customModules.accelerationData.xSmooth / 10).toFixed(1);
      // var roundedGY2 = (-data.customModules.accelerationData.ySmooth / 10).toFixed(1);
      // infoDisplay.gXPositive.text(roundedGX2 > 0 ? roundedGX2  : 0)
      // infoDisplay.gXNegative.text(roundedGX2 < 0 ? -roundedGX2 : 0)
      // infoDisplay.gYNegative.text(roundedGY2 > 0 ? roundedGY2  : 0)
      // infoDisplay.gYPositive.text(roundedGY2 < 0 ? -roundedGY2 : 0)
    }

    function updateGagueFuel(data) {
      if (speedoInitialised) {
        //cachedVal.fuel
        let pos = gagues.fuel.path.n.getPointAtLength(data["electrics"]["fuel"] * gagues.fuel.path.n.getTotalLength())
        gagues.fuel.needle.n.style.transform = "translate("+pos.x+"px, "+(pos.y+4)+"px)"
        gagues.fuel.grad.attr({y2: pos.y})
      }
    }

    function updateGagueTemp(data) {
      if (speedoInitialised) {
        //cachedVal.fuel
        let pos = gagues.temp.path.n.getPointAtLength(data["electrics"]["fuel"] * gagues.temp.path.n.getTotalLength())
        gagues.temp.needle.n.style.transform = "translate("+pos.x+"px, "+(pos.y+4)+"px)"
        gagues.temp.grad.attr({y2: pos.y})
      }
    }


    // overwriting plain javascript function so we can access from within the controller
    $window.setup = (data) => {
      if(!ready){
        console.log("calling setup while svg not fully loaded");
        setTimeout(function(){ $window.setup(data) }, 100);
        return;
      }

      //console.log("setup",data);
      if(data.uiUnitLength == "metric"){
        speedoDisplay.speedUnit.text("KM/H");
        unitspeedConv = 3.6;
      }
      else{
        speedoDisplay.speedUnit.text("MPH");
        unitspeedConv = 2.23694;
      }
      unitTorque = data.uiUnitTorque;
      unitPower = data.uiUnitPower;
      unitLength = data.uiUnitLength;
    }

    function setElec(val, state, key){
      if( val === undefined || val === null){console.error("setElec: svg element not found", key); return;}
      if( state === undefined || state === null){console.error("setElec: state not found", key);val.n.style.display = "none"; return;}
      var cssState = (state===true || state>0.1)?"inline":"none";
      val.n.style.display = cssState;
      //val.n.setAttribute("opacity", (state || state>0.1)?1.0:0.3)
    }

    $window.updateElectrics = (data) => {
      // for(var k in electrics.lights){
      //   setElec(electrics.lights[k], data.electrics[k], k);
      // }

      electrics.battery_txt.text((data["electrics"]["fuel"]*100).toFixed(0) + "%")

      if(cachedVal.dragMode === true){
        dragLayer.linelock_light.css({"fill":(data.electrics.linelock > 0.1)?"#70ff5c":"#000"});
        dragLayer.transbrake_light.css({"stroke":(data.electrics.transbrake > 0.1)?"#ef3535":"#000"});
        if (data.customModules && data.customModules.combustionEngineData){
          let tmp = data.customModules.combustionEngineData.currentTorque;
          if(unitTorque=="imperial"){
            tmp *= 0.7376;
            dragLayer.torque_txt.text(tmp.toFixed()+" lb.ft")
          }
          else{//metric
            dragLayer.torque_txt.text(tmp.toFixed()+" NM")
          }
          tmp = data.customModules.combustionEngineData.currentPower;
          tmp = tmp>0?tmp:0
          switch(unitPower){
            case 'kw':
              tmp *= 0.7355;
              dragLayer.power_txt.text(tmp.toFixed()+" kW")
              break;
            case 'hp':
            case 'bhp':
              dragLayer.power_txt.text(tmp.toFixed()+" HP")
              break;
          }
        }
        else{
          dragLayer.torque_txt.text("err lb.ft")
          dragLayer.power_txt.text("err HP")
        }
      }
      if(data.electrics.odometer){
        let val = data.electrics.odometer
        val *= (unitLength=="metric")?0.001:0.0006215;
        val = Math.min(999999,val);
        electrics.odo_txt.text( val.toFixed(0)+" "+((unitLength=="metric")?"km":"mi") )
      }
    }

    //https://stackoverflow.com/a/56266358
    function isColor(strColor){
      var s = new Option().style;
      s.color = strColor;
      return s.color !== "";
    }

    $window.updateMode = (data) => {
      if(!ready){
        console.log("calling updateMode while svg not fully loaded");
        setTimeout(function(){ $window.updateMode(data) }, 100);
        return;
      }
      //error checking because we can't trust people we work with
      // if(data === null
      // || data === undefined
      // || data.modeName === null
      // || data.modeName === undefined
      // || typeof data.modeName !== "string"
      // || data.modeColor === null
      // || data.modeColor === undefined
      // || typeof data.modeColor !== "string"){
      //   console.error("updateMode receive wrong arguments :", data);
      //   document.getElementById("layer_wip").style.display = "inline";
      //   document.getElementById("tspan995").innerHTML = "MODE";
      //   return;
      // }
      // if(!isColor(data.modeColor)){
      //   console.error("This mode color is not in html format :",data.modeColor)
      //   document.getElementById("layer_wip").style.display = "inline";
      //   document.getElementById("tspan995").innerHTML = "COL";
      //   return;
      // }

      //if you fixed without reload
      // if(document.getElementById("tspan995").innerHTML === "COL"
      // ||document.getElementById("tspan995").innerHTML === "MODE"){
      //   document.getElementById("layer_wip").style.display = "none";
      // }

      //hex color without # works in html but not in svg BECAUSE
      var s = new Option().style;
      s.color = data.modeColor;
      data.modeColor = s.color;

      electrics.mode_txt.text(data.modeName);

      hu('#stop6', svg).css({"stop-color": data.modeColor});

      cachedVal.gForcesVisible = data.modeName.toLowerCase() != "comfort" && data.modeName.toLowerCase() != "savage" && data.modeName.toLowerCase() != "caged";
      cachedVal.dragMode = data.modeName.toLowerCase() == "savage";

      if(cachedVal.gForcesVisible || cachedVal.dragMode)
        speedoDisplay.rootspeedo.css({display: "none"});
      else
        speedoDisplay.rootspeedo.css({display: "block"});

      if (cachedVal.gForcesVisible === true){
        gmeter.root.css({display: "block"})
      }
      else {
        gmeter.root.css({display: "none"})
      }
      if (cachedVal.dragMode === true){
        dragLayer.root.css({display: "block"});
      }
      else {
        dragLayer.root.css({display: "none"});
      }
    }

    $window.updateData = (data) => {
      if (data) {
        if(!ready){console.log("not ready");return;}
        // console.log(data);
        //hue = (hue+.5) % 360;
        //setTheme(hue);

        // Update Gear display
        if(isNaN(data.electrics.gear) || data.electrics.gear >= 1)
          speedoDisplay.gear.text(data.electrics.gear)
        else{
          switch(data.electrics.gear){
            case -1:
              speedoDisplay.gear.text("R")
              break;
            case 0:
              speedoDisplay.gear.text("N")
              break;
            default:
              speedoDisplay.gear.text("???")
              break;
          }
        }


        // Update Speed displays
        speedoDisplay.speedometerText.text( (data.electrics.wheelspeed * unitspeedConv).toFixed())

        updateElectrics(data);
        updateGagueFuel(data);
        updateGagueTemp(data);

        if (cachedVal.gForcesVisible === true) {
          updateAccelerometer(data);
        }
      }
    }
    //ready = true;
  });