-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
M.type = "auxiliary"
M.relevantDevice = nil

local electricsName = nil
--local soundEletricsName = nil
local isWarning = false
local soundLoopName = nil
local soundLoop = nil
local soundVolume = 1
local tick = 0
local soundNode = 0
local soundPitch = 1
local soundVolumeNeededVolume = 1
local soundVolumeSmoother = newExponentialSmoothingT(40)

local function updateGFX(dt)
  --tick = tick + dt
    --if tick >= 0.5 then
      --tick = 0
      soundVolume = soundVolumeSmoother:get(soundVolumeNeededVolume)
      soundPitch = 2.5 + electrics.values.wheelspeed / 9
      obj:setVolumePitch(soundLoop, soundVolume, soundPitch)
      if (electrics.values[electricsName] or 0) > 0 then
        if electrics.values.wheelspeed <= 8.33333 and electrics.values.wheelspeed >= 0.25 then
          obj:playSFX(soundLoop)
          soundVolumeNeededVolume = 1
        end
      if electrics.values.wheelspeed < 0.1 or electrics.values.wheelspeed > 8.33333 then
        obj:stopSFX(soundLoop)
        soundVolumeNeededVolume = 0
      end
      --print(soundVolume) -- debug
    --end
  end
end

local function reset()
end

local function init(jbeamData)
  --soundElectricsName = "wheelspeed"
  electricsName = "wheelspeed"
  soundLoopName = jbeamData.soundLoopName or "art/sound/ebastion_evpws/spaceship_evpws.ogg"
  soundVolume = jbeamData.soundVolume or 4
end

local function initSounds()
  soundLoop = obj:createSFXSource2(soundLoopName, "AudioClosestLoop3D", "30kphsound", soundNode, 0)
end

M.init = init
M.initSounds = initSounds
M.reset = reset
M.updateGFX = updateGFX

return M
